PGSQL_CONTROL
-- $Id: net_math.m4,v 1.5 2005/08/08 15:23:40 dem Exp $
CREATE OR REPLACE FUNCTION ipaggr_in(cstring) RETURNS ipaggr
 AS '$libdir/net_math.so.VMAJOR'
  , 'ipaggr_in'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION ipaggr_out(ipaggr) RETURNS cstring
 AS '$libdir/net_math.so.VMAJOR'
  , 'ipaggr_out'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION add_net(ipaggr,inet) RETURNS ipaggr
 AS '$libdir/net_math.so.VMAJOR'
  , 'add_net'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION sub_net(ipaggr,inet) RETURNS ipaggr
 AS '$libdir/net_math.so.VMAJOR'
  , 'sub_net'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION add_ipaggr(ipaggr,ipaggr) RETURNS ipaggr
 AS '$libdir/net_math.so.VMAJOR'
  , 'add_ipaggr'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION sub_ipaggr(ipaggr,ipaggr) RETURNS ipaggr
 AS '$libdir/net_math.so.VMAJOR'
  , 'sub_ipaggr'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION inter_ipaggr(ipaggr,ipaggr) RETURNS ipaggr
 AS '$libdir/net_math.so.VMAJOR'
  , 'inter_ipaggr'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION show_net(ipaggr) RETURNS SETOF cidr
 AS '$libdir/net_math.so.VMAJOR'
  , 'show_net'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION check_net(ipaggr,inet) RETURNS boolean
 AS '$libdir/net_math.so.VMAJOR'
  , 'check_net'
 LANGUAGE C IMMUTABLE STRICT
;

CREATE TYPE ipaggr (
   internallength = VARIABLE, 
   input = ipaggr_in,
   output = ipaggr_out,
   alignment = double,
   storage = external
);

CREATE AGGREGATE sum_net (
    sfunc = add_net,
    basetype = inet,
    stype = ipaggr,
    initcond = 'f'
);

CREATE OPERATOR + (
    leftarg = ipaggr,
    rightarg = ipaggr,
    procedure = add_ipaggr,
    commutator = +
);

CREATE OPERATOR - (
    leftarg = ipaggr,
    rightarg = ipaggr,
    procedure = sub_ipaggr,
    commutator = -
);

CREATE OPERATOR * (
    leftarg = ipaggr,
    rightarg = ipaggr,
    procedure = inter_ipaggr,
    commutator = *
);

CREATE OPERATOR + (
    leftarg = ipaggr,
    rightarg = inet,
    procedure = add_net,
    commutator = +
);

CREATE OPERATOR - (
    leftarg = ipaggr,
    rightarg = inet,
    procedure = sub_net,
    commutator = -
);

COMMENT ON FUNCTION ipaggr_in(cstring)	IS '   IP ';
COMMENT ON FUNCTION ipaggr_out(ipaggr)	IS ' IP   ';
COMMENT ON FUNCTION add_net(ipaggr,inet)	IS '  IP  ';
COMMENT ON FUNCTION add_ipaggr(ipaggr,ipaggr)	IS '  IP ';
COMMENT ON FUNCTION sub_net(ipaggr,inet)	IS '  IP  ';
COMMENT ON FUNCTION sub_ipaggr(ipaggr,ipaggr)	IS '  IP ';
COMMENT ON FUNCTION show_net(ipaggr)	IS ' IP    ';
COMMENT ON AGGREGATE sum_net(inet)	IS '   IP ';
